// 002 u_environnment_rsvars_registry
// 19 apr 2018

// -- (C) Felix John COLIBRI 2018
// -- documentation: http://www.felix-colibri.com

(*$r+*)

unit u_environnment_rsvars_registry;
  Interface
    Uses Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs
        , StdCtrls, FileCtrl, ExtCtrls, ComCtrls
        ;

    type TForm1=
             class(TForm)
                 command_panel: tPanel;
                 exit_panel: tPanel;
                 exit_: tButton;
                 clear_: tButton;
                 help_: tButton;
                 dir_file_panel: tPanel;
                 favorites_panel: tPanel;
                 DirectoryListbox1: tDirectoryListbox;
                 dir_file_splitter: tSplitter;
                 file_panel: tPanel;
                 FileListbox1: tFileListbox;
                 bottom_panel: tPanel;
                 left_splitter: tSplitter;
                 display_pagecontrol: tPageControl;
                 display_tabsheet: tTabSheet;
                 Memo1: tMemo;
    environment_: TButton;
    path_: TButton;
    rsvars_: TButton;
    registry_: TButton;
    compiler_listbox_: TListBox;
                 Procedure Form1Create(Sender: tObject);
                 Procedure Form1Close(Sender: TObject; var Action: TCloseAction);
                 Procedure exit_Click(Sender: tObject);
                 Procedure clear_Click(Sender: tObject);
                 Procedure help_Click(Sender: tObject);
                 Procedure DirectoryListbox1Change(Sender: tObject);
                 Procedure FileListbox1Click(Sender: tObject);
    procedure environment_Click(Sender: TObject);
    procedure path_Click(Sender: TObject);
    procedure rsvars_Click(Sender: TObject);
    procedure registry_Click(Sender: TObject);
    procedure compiler_listbox_Click(Sender: TObject);
               private
                 procedure handle_favorite_path_click(p_path, p_extension: String);
               public
             end; // TForm1

    var Form1: tForm1= Nil;

  implementation
    Uses u_c_display, u_c_log
        , u_help
        , u_c_favorite_path_list
        , u_exe
        , u_file, u_dir
        , u_c_ini_file
        , u_handle_files_in_dirs

        , u_c_environment
        , u_strings

        , u_c_delphi_compiler_list
        ;

    {$R *.DFM}

    Const k_xxx_path=                'c:\prog\xxx\';
          k_xxx_file_name=           'pascal.pas';
          k_xxx_path_ini_key=        'ini_xxx_path';
          k_xxx_file_name_ini_key=   'ini_xxx_file_name';

    Var g_path:          String= k_xxx_path;
        g_file_name:     String= k_xxx_file_name;
        g_c_ini_file:    c_ini_file= Nil;
        g_file_count:    Integer= 0;
        g_c_favorite_path_list: c_favorite_path_list= Nil;

        g_c_delphi_compiler_list: c_delphi_compiler_list= Nil;
        
    procedure display_path_and_file;
      begin
        Form1.Caption:= g_path+ g_file_name;
      end; // display_path_and_file

    procedure my_call_back(p_level: Integer; p_path, p_file_name: String;
        p_pt_data: Pointer);
      begin
        // -- CAUTION if 2 dirs
        // g_path:= p_path; g_file_name:= p_file_name;
        display_path_and_file;
        // Form1.load_Click(Nil);

        Inc(g_file_count);

        display('  '+ p_file_name);
(*
        with g_c_find_memo do
        begin
          m_save_path:= g_path;
          m_c_memo.Lines.LoadFromFile(g_path+ g_file_name);
          m_c_save_edit.Text:= g_file_name;
        end;
*)
      end; // my_call_back

    // -- events

    procedure TForm1.Form1Create(Sender: TObject);
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;
        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_path:= f_initialize_parameter(k_xxx_path_ini_key, k_xxx_path);
          g_file_name:= f_initialize_parameter(k_xxx_file_name_ini_key, k_xxx_file_name);
        end; // with g_c_ini_file
        display_path_and_file;

        // check_name(k_initial_directory);
        // DirectoryListBox1.Directory:= k_initial_directory;

        g_c_favorite_path_list:= c_favorite_path_list.create_favorite_path_list(
            f_exe_path+ 'favorites\'+ f_exe_pure_project_name+ '_favorites.txt',
            favorites_panel, handle_favorite_path_click);

        set_directory_listbox_directory(DirectoryListBox1, g_path);
        with FileListBox1, Items do
          ItemIndex:= IndexOf(g_file_name);
      end; // Form1Create

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.Form1Close(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // Form1Close

    // -- call handler

    procedure TForm1.DirectoryListBox1Change(Sender: TObject);
      begin
        with DirectoryListBox1 do
          g_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_xxx_path_ini_key, g_path);
        // display_path_and_file;
      end; // DirectoryListBox1Change

    procedure TForm1.FileListBox1Click(Sender: TObject);
      // -- the file clicked in the bottom list_box
      // var l_path, l_name: String;
      begin
        // l_path:= DirectoryListBox1.Directory;
        with FileListbox1 do
          g_file_name:= Items[ItemIndex];
        // Form1.load_Click(Nil);
        g_c_ini_file.set_parameter(k_xxx_file_name_ini_key, g_file_name);

        g_file_count:= 0;
        my_call_back(0, g_path, g_file_name, Nil);
        // TODO update the ini 
        g_c_ini_file.save_to_default_file;
      end; // FileListBox1Click

    procedure handle_the_files(p_dir_handling_types: t_dir_handling_types);
      var l_extension: String;
          l_path: String;
      begin
(*
        l_path:= f_without_ending_slash(k_initial_directory);
        l_extension:= '.HTML';

        with DirectoryListBox1 do
          l_path:= f_without_ending_slash(GetItemPath(ItemIndex));
        l_extension:= FilterComboBox1.Filter;
*)
        l_path:= f_without_ending_slash(g_path);

        l_extension:= Form1.FileListBox1.Mask;
        Delete(l_extension, 1, 1);
        l_extension:= UpperCase(l_extension);

        display_line;
        display('handle_non_rec of '+ l_path+ ' '+ l_extension);
        display_line;
        g_file_count:= 0;

        handle_all_files_recursive(1, l_path, l_extension,
            p_dir_handling_types, my_call_back, Nil);

        display_line;
        display(Format('FINISHED %3d ', [g_file_count]));
      end; // handle_the_files

    procedure tForm1.handle_favorite_path_click(p_path, p_extension: String);
      begin
        set_directory_listbox_directory(DirectoryListbox1, p_path);
      end; // handle_favorite_path_click

    procedure TForm1.help_Click(Sender: TObject);
      begin
        display_help;
      end; // help_Click

    procedure TForm1.environment_Click(Sender: TObject);
(*
      const k_max= 255;
      var l_environment_value: String[k_max];
          l_size: Integer;
        l_size:= GetEnvironmentVariable(p_key, @ l_environment_value[1], k_max);
        l_environment_value[0]:= chr(l_size);
        Result:= l_environment_value;

        with c_environment.create_environment('') do
        begin
        end;
*)
      var l_environment: String;
      begin
        l_environment:= f_get_all_environment_string;
        display('size '+ IntToStr(Length(l_environment)));
        display(l_environment);
      end;

    procedure TForm1.path_Click(Sender: TObject);
      var l_full_path, l_path: String;
          l_index: Integer;
      begin
        l_full_path:= f_get_environment_value_2('Path');
        Caption:= 'size '+ IntToStr(Length(l_full_path));

        clear_display;
        l_index:= 1;

        while l_index<= Length(l_full_path) do
        begin
          l_path:= f_string_extract_until(l_full_path, ';', l_index);
          display(l_path);
          Inc(l_index);
        end;
      end;

    procedure TForm1.rsvars_Click(Sender: TObject);
      var l_c_rsvars_list: tStringList;

      function _f_detailed_path(p_path: String): String;

        function _f_definition(p_key: String): String;
          begin
            Result:= l_c_rsvars_list.Values['@SET '+ p_key];
          end; // _f_definition

        var l_index: Integer;
            l_key: String;

        begin // _f_detailed_path
          Result:= '';
          l_index:= 1;
          // display('  '+ p_path);
          while l_index<= Length(p_path) do
          begin
            if p_path[l_index]= '%'
              then begin
                  Inc(l_index);
                  l_key:= '';
                  while (l_index<= Length(p_path)) and (p_path[l_index]<> '%') do
                  begin
                    l_key:= l_key+ p_path[l_index];
                    inc(l_index);
                  end;
                  if l_key= 'PATH'
                    then Result:= '"the windows PATH"'
                    else Result:= Result+ _f_definition(l_key);
                  Inc(l_index);
                end
              else Result:= Result+ p_path[l_index];
            Inc(l_index);
          end;
        end; // _f_detailed_path

      var l_full_path: String;

          l_index: Integer;
          l_path: String;
          l_detailed_path: String;

      begin // rsvars_Click
        l_c_rsvars_list:= tStringList.Create;
        with l_c_rsvars_list do
        begin
          LoadFromFile(g_path+ g_file_name);

          l_full_path:= Values['@SET PATH'];
          display_line;
          display('----- raw_path');
          display(l_full_path);

          display_line;
          display('----- separate_pathes');
          l_index:= 1;
          while l_index<= Length(l_full_path) do
          begin
            l_path:= f_string_extract_until(l_full_path, ';', l_index);
            display(l_path);
            Inc(l_index);
          end;

          display_line;
          display('----- separate_detailed_pathes');
          l_index:= 1;

          while l_index<= Length(l_full_path) do
          begin
            l_path:= f_string_extract_until(l_full_path, ';', l_index);
            l_detailed_path:= _f_detailed_path(l_path);
            display(l_detailed_path);
            Inc(l_index);
          end;

          Free;
        end;
      end;

    procedure TForm1.registry_Click(Sender: TObject);
      var l_compiler_index: Integer;
      begin
        g_c_delphi_compiler_list := c_delphi_compiler_list.Create;
        g_c_delphi_compiler_list.initialize_compiler_list('');

        with compiler_listbox_ do
        begin
          for l_compiler_index:= 0 to g_c_delphi_compiler_list.f_compiler_count- 1 do
            Items.AddObject(g_c_delphi_compiler_list.f_c_delphi_compiler(l_compiler_index).m_delphi_version_name,
                g_c_delphi_compiler_list.f_c_delphi_compiler(l_compiler_index));

          if Items.Count > 0 then
            ItemIndex:= 0;
        end; // with compiler_listbox_
      end;

    procedure TForm1.compiler_listbox_Click(Sender: TObject);
      begin
        clear_display;
        with compiler_listbox_, Items, c_delphi_compiler(Objects[ItemIndex]) do
          display_delphi_compiler
      end; // compiler_listbox_Click

end. // environnment

